# F.A.Q. and Known Issues
List of commonly asked questions and known bugs.

---
## **Client**

---
#### **How do I install BeamMP?**

There is a full guide on how to install BeamMP on Windows, you can find it [here](https://docs.beammp.com/game/getting-started/).

---
#### **Does BeamMP work on a cracked version of BeamNG?**

BeamMP does not work with cracked versions or outdated versions of BeamNG.drive. If you want to use BeamMP please consider buying the game.

---
#### **Does BeamMP work on linux?**

The Client is not officially  supported on Linux. However, you might be able to get it working by running the launcher in the same proton prefix as the game.

---
#### **Why is the launcher flagged by my antivirus or by Windows Defender**

In order to prevent Windows Defender from flagging a specific .exe, we need to buy a license which is very expensive, therefore, BeamMP might get flagged by Windows Defender.

Some antivirus may flag BeamMP as a virus  beacause it does some interactions with network and other stuff. There are **no viruses** in any of the code. The code for the launcher, server, and lua client can be seen on our [GitHub](https://github.com/BeamMP).

---
#### **I have poor performance, what should I do?**

We are working hard to make performance as good as possible. Sadly, there isn't a lot you can do about it, if you have already lowered your graphic settings and your performance is still poor, consider playing on a server with less players. The game is mainly CPU bound when you play with lots of people, so older CPUs (even quadcores) will suffer with more than a handful of people.

---
## **Miscellaneous**

---
#### **Where can I find the code?**

All the source code can be found on our [GitHub](https://github.com/BeamMP).
Before doing anything keep in mind that the code is subject to our [Terms of Use](https://forum.beammp.com/t/terms-of-use-v1-0/43) and licenses:

|   Code     | License                                                                    |
|------------|:--------------------------------------------------------------------------:|
| Server     | [LICENSE](https://github.com/BeamMP/BeamMP-Server/blob/master/LICENSE)     |
| Launcher   | [LICENSE](https://github.com/BeamMP/BeamMP-Launcher/blob/master/README.md) |
| Client Lua | [LICENSE](https://github.com/BeamMP/BeamMP/blob/development/LICENSE.md)    |

---
#### **I have found a bug or an exploit what should I do?**

If the issue is code related and you know how to use Github, create a new "Issue" in the appropriate repository on our [GitHub](https://github.com/BeamMP). We use an issue-based workflow so even if you already have a fix for the bug, consider opening a new "Issue", then asking a "Pull Request" that solves your "Issue". More info on contributing can be found [here](https://github.com/BeamMP/BeamMP/blob/development/CONTRIBUTING.md).

If you don't have a GitHub account or you don't know how to use GitHub you can get in touch with us in the following ways:

- If it is not something sensitive, you can create a post on our [BeamMP Forum](https://forum.beammp.com) or you can report this on our [Official Discord](https://discord.gg/beammp).
- If the information is sensitive you can directly report the issue to a Staff member on our [Discord](https://discord.gg/beammp).